## mingw-w64-xalan-c-1.12-13.src.tar.zst

=== src/xalanc/Utils/XalanMsgLib/CMakeLists.txt ===
# CMake build for xalan-c
#
# Written by Roger Leigh <rleigh@codelibre.net>
#
# Licensed to the Apache Software Foundation (ASF) under one or more
# contributor license agreements.  See the NOTICE file distributed with
# this work for additional information regarding copyright ownership.
# The ASF licenses this file to You under the Apache License, Version 2.0
# (the "License"); you may not use this file except in compliance with
# the License.  You may obtain a copy of the License at
#
#      http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

if(msgloader STREQUAL "inmemory")

  set(msglib_sources
    XalanMsgLib.cpp)

  set(msglib_headers
    XalanMsgLib.hpp
    XalanMsgLibDefinitions.hpp)

  set(msglib_resources
    XalanMsgLib.rc)

  add_library(xalanMsg ${msglib_sources} ${msglib_headers} ${msglib_resources})
  add_dependencies(xalanMsg locale)
  target_compile_definitions(xalanMsg PRIVATE "${MSGLOADER_DEF}=1")
  if(BUILD_SHARED_LIBS)
    target_compile_definitions(xalanMsg PRIVATE XALAN_XALANMSGLIB_BUILD_DLL=1)
  endif()
  target_include_directories(xalanMsg PUBLIC
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/src>
    $<BUILD_INTERFACE:${PROJECT_BINARY_DIR}/src>
    $<BUILD_INTERFACE:${PROJECT_BINARY_DIR}/src/xalanc/PlatformSupport>
    $<BUILD_INTERFACE:${PROJECT_BINARY_DIR}/src/xalanc/NLS/include>
    $<INSTALL_INTERFACE:include/xalanc>)
  target_link_libraries(xalanMsg XercesC::XercesC)

  add_library(XalanC::XalanMsg ALIAS xalanMsg)

  if(MSVC)
    # Add configuration-specific library name to resource file.
    target_compile_definitions(xalanMsg PRIVATE "XALAN_DLL_NAME=\"$<TARGET_FILE_NAME:xalanMsg>\\0\"")
    # Different naming for Windows than for Unix builds for backward
    # compatibility with the existing project files.
    set_target_properties(xalanMsg PROPERTIES OUTPUT_NAME "XalanMsgLib_${XALAN_MS_LIB_MAJOR_VER}")
    set_target_properties(xalanMsg PROPERTIES RUNTIME_OUTPUT_NAME "XalanMessages_${XALAN_MS_LIB_MAJOR_VER}_${XALAN_MS_LIB_MINOR_VER}")
    set_target_properties(xalanMsg PROPERTIES DEBUG_POSTFIX "D")
  else()
    # Not used for the common cases, though this would be the default if
    # not for libtool compatibility.
    set_target_properties(xalanMsg PROPERTIES SOVERSION ${XALAN_LIB_MAJOR_VER})
    if(NOT CYGWIN)
      # This property causes shared libraries on Linux to have the full
      # version encoded into their final filename.  We disable this on
      # Cygwin because it causes xalanMsg-${XALAN_C_FULL_VERSION}.dll
      # to be created when xalanMsg.dll seems to be the default.
      set_target_properties(xalanMsg PROPERTIES VERSION ${XALAN_LIB_MAJOR_VER}.${XALAN_LIB_MINOR_VER})
    endif()
  endif()
  set_target_properties(xalanMsg PROPERTIES FOLDER "Message Library")

  install(TARGETS xalanMsg
    EXPORT XalanCConfigInternal
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
    COMPONENT "runtime"
    INCLUDES DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}")

endif()

=== PKGBUILD ===
# Maintainer: Alexey Pavlov <alexpux@gmail.com>

_realname=xalan-c
pkgbase=mingw-w64-${_realname}
pkgname="${MINGW_PACKAGE_PREFIX}-${_realname}"
pkgver=1.12
pkgrel=13
pkgdesc="An XSLT processing library (mingw-w64)"
arch=('any')
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
url="https://xalan.apache.org/xalan-c"
license=('spdx:Apache-2.0')
depends=("${MINGW_PACKAGE_PREFIX}-gcc-libs"
         "${MINGW_PACKAGE_PREFIX}-icu"
         "${MINGW_PACKAGE_PREFIX}-xerces-c")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-doxygen"
             "${MINGW_PACKAGE_PREFIX}-tools")
source=(https://archive.apache.org/dist/xalan/xalan-c/sources/xalan_c-${pkgver}.tar.gz
        01-mingw-icu.patch
        02-mingw-as-msvc.patch
        03-install-layout.patch
        04-no-std-file.patch
        05-set-cxx-std-17.patch
        06-fix-build-with-clang-19.patch)
sha256sums=('ee7d4b0b08c5676f5e586c7154d94a5b32b299ac3cbb946e24c4375a25552da7'
            '64ca2fb25114fd9c35c0a0815c7308ab3222eb421965892a402c4f30d23f180b'
            '8ccef1339fcfb6472861545295a9cb72a6b8da3a81407d082a5df51ac5f5c8e0'
            '35f2cf6b4aefb29c1c88f94b808c07a2b2845c025f236b38f4e31b5e378ba874'
            '0b2bcce90c90261e309a7d3914631f91deaca00930acda487c9b828c581ea968'
            '1af451cf368fc50e48ffc6f17f987f4e51e9facd1e811ca477026d88eedee9bb'
            '507de5146717d647775af15ae1f59d4584b5060ea038da4531a42cd124750a8d')

apply_patch_with_msg() {
  for _patch in "$@"
  do
    msg2 "Applying $_patch"
    patch -Np1 -i "${srcdir}/$_patch"
  done
}

prepare(){
  cd "${srcdir}"/${_realname//-/_}-${pkgver}
  apply_patch_with_msg \
    01-mingw-icu.patch \
    02-mingw-as-msvc.patch \
    03-install-layout.patch \
    04-no-std-file.patch \
    05-set-cxx-std-17.patch \
    06-fix-build-with-clang-19.patch
}

build() {
  declare -a extra_config
  if check_option "debug" "n"; then
    extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  mkdir -p "${srcdir}"/build-${MSYSTEM} && cd "${srcdir}"/build-${MSYSTEM}

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
    ${MINGW_PREFIX}/bin/cmake.exe \
      -G"Ninja" \
      -DCMAKE_INSTALL_PREFIX=${MINGW_PREFIX} \
      -DCMAKE_CXX_STANDARD=17 \
      "${extra_config}" \
      -DBUILD_SHARED_LIBS=ON \
      -DCMAKE_POLICY_VERSION_MINIMUM=3.5 \
      ../${_realname//-/_}-${pkgver}

  ${MINGW_PREFIX}/bin/cmake.exe --build ./
}

package() {
  cd "${srcdir}/build-${MSYSTEM}"

  DESTDIR="${pkgdir}" ${MINGW_PREFIX}/bin/cmake.exe --install ./

  install -Dm644 "${srcdir}"/${_realname//-/_}-${pkgver}/LICENSE \
    "${pkgdir}${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE"
}
